<template>
  <div id="q-app">
    <router-view />
  </div>
</template>

<script>
// import { userSession, blockstack, userData } from "boot/blockstack";
import { mapActions } from "vuex";
// import { userSession } from "boot/blockstack";
import { authenticate, showBlockstackConnect } from "@blockstack/connect";

export default {
  name: "App",
  created() {
    this.$root.$on("login", this.signIn);
  },
  beforeDestroy() {
    this.$root.$off("login", this.signIn);
  },
  mounted() {
    if (this.$userSession.isUserSignedIn()) {
      // this.fetchData();
      this.setProfile();
    } else if (this.$userSession.isSignInPending()) {
      this.$userSession.handlePendingSignIn().then(() => {
        window.location = window.location.href.split("?")[0];
        this.setProfile();
      });
    }
  },
  methods: {
    ...mapActions({
      setUser: "user/setUser",
      intializeData: "search/initializeFromGaia",
    }),
    signIn() {
      const authOptions = {
        appDetails: {
          name: "Land Ho!",
          icon: "/app-logo-128x128.png",
        },
        userSession: this.$userSession,
        manifestPath: "/manifest.json",
        finished: async () => {
          this.setProfile();
        },
      };

      showBlockstackConnect(authOptions);
    },
    setProfile() {
      let userData = this.$userSession.loadUserData();
      this.setUser(userData);
      this.$userSession.getFile("landho.json").then((data) => {
        let searches = JSON.parse(data) || [];
        if (process.env.DEV) console.log("searches loaded: ", searches);
        this.intializeData(searches);
      });
      if (this.$route.path !== "/app/search") {
        this.$router.push("/app/search");
      }
    },
  },
};
</script>

<style></style>
